/**************************************************************************************************

Copyright (c) 2007-2015   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_PLANETARY_RING_H__
#define __MTK_PLANETARY_RING_H__
#include  "../common/math/vector3.h"
#include  "../common/graphics/gl_common.h"
#include  "../common/graphics/color.h"
#include  "../common/JulianDate.h"
#include  "../common/astro/astrometry.h"
#include  "mtk_draw_struct.h"
#include  <string>


const int particle_ring_RN   =  30;
const int particle_ring_PHIN = 180;




class  particle_ring
{
private:
	float		R1, R2;
	vector3f	pos[particle_ring_RN][particle_ring_PHIN+1];
	float		s[particle_ring_RN];
	float		shadow_fac[particle_ring_RN][particle_ring_PHIN + 1];
	bool		b_shadow_boundary[particle_ring_RN][particle_ring_PHIN + 1];
	int			last_mode;
	bool		bLastSideLight;
	double		JD;
	float		alp;	// fɗƂep̓x

	//---  Textures
	std::string tex_file_name;
	GLuint tex_idx;


public:
	particle_ring(float _R1, float _R2, float _alp, const std::string& tex_fn);
	float	get_R1() const	{ return R1; }
	float	get_R2() const	{ return R2; }
	float	get_alpha() const { return alp; }

	void	calc_shadow_factor(const mtk_draw_struct& ds, const vector3d& r0, const double& R, const double& f, const vector3d& ex, const vector3d& ey, const vector3d& ez, const vector3d& _lv);

	// Textures
	GLuint		load_texture(int shrink_rate);
	GLuint		get_texture_index() const	{ return tex_idx; }


	void	draw_triangles(const vector2f* pt, const float *u, const float *f, const int *pt_idx, const int N, bool bShadow) const;
	void	draw_boundary_mesh(int i, int j) const;

	void	draw(const mtk_draw_struct& ds, const vector3d& r0, const double& R, const vector3d& ex, const vector3d& ey, const vector3d& lv)  const;
	void	draw_3Dchart() const;
};




void	draw_ring_shaded_sphere(const vector3d& r0, const double& R, const double& f, const vector3d& ex, const vector3d& ey, const vector3d& ez, const vector3d &_lv, const particle_ring& pr, const GLuint texPlanet, const RGBf& mat_col);





int		add_particle_ring(float R1, float R2, float alp, const std::string& tex_fn);
particle_ring&	get_particle_ring(int idx);

void	load_ring_textures();




// for init
struct ring_info {
	double  Rr1, Rr2;	// ւ̓aAOaiԓaPʂƂāj
	float	ring_alp;	// fɗƂep̓x
	const char* tex_fn;	// ÕeNX`̃t@C
};


#endif
